/*
 *******************************************************************
 *              TMark favorites plugin for TVBrowser               *
 *                                                                 *
 * Copyright (C) 2006 Tomas Schackert.                             *
 * Contact koumori@web.de                                          *
 *******************************************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, in version 2 of the License.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program, in a file called LICENSE in the top
 directory of the distribution; if not, write to 
 the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA  02111-1307  USA
 
 *******************************************************************/

package tmarkplugin.properties;

import java.awt.Dimension;
/**
 * tmarkplugin.config.Property for a Dimension
 * @author Tomas Schackert
 *
 */
public class DimensionProperty extends Property{
	String key;
	int width=0,height=0;
	int defaultwidth,defaultheight=0;
	boolean loaded=false;
	public DimensionProperty(PropertySource props,DimensionProperty src){
		super(props);
		setDimension(src);
	}
	
	public DimensionProperty(PropertySource props,String key,Dimension defaultvalue){
		super(props);
		this.key=key;
		defaultwidth=defaultvalue.width;
		defaultheight=defaultvalue.height;
	}
	public DimensionProperty(PropertySource props,String key,int defaultwidth,int defaultheight){
		super(props);
		this.key=key;
		this.defaultwidth=defaultwidth;
		this.defaultheight=defaultheight;
	}
	private void load(){
		width=this.getIntProperty(key+".width",defaultwidth);
		height=this.getIntProperty(key+".height",defaultheight);
		loaded=true;
	}
	public void setDimension(DimensionProperty src){
		if (!src.loaded)src.load();
		this.key=src.key;
		defaultwidth=src.defaultwidth;
		defaultheight=src.defaultheight;
		setDimension(src.width,src.height);
	}
	public Dimension getDimension(){
		if (!loaded) load();
		return new Dimension(width,height);
	}
	public void setDimension(Dimension v){
		setDimension(v.width,v.height);
	}
	public void setDimension(int w,int h){
		this.setIntProperty(key+".width",width=w);
		this.setIntProperty(key+".height",height=h);
		loaded=true;
		fireChanged();
	}
	public void reset() {
		setDimension(defaultwidth,defaultheight);
	}
}
