/*
 *******************************************************************
 *              TMark favorites plugin for TVBrowser               *
 *                                                                 *
 * Copyright (C) 2006 Tomas Schackert.                             *
 * Contact koumori@web.de                                          *
 *******************************************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, in version 2 of the License.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program, in a file called LICENSE in the top
 directory of the distribution; if not, write to 
 the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA  02111-1307  USA
 
 *******************************************************************/

package tmarkplugin.properties;

/**
 * tmarkplugin.config.Property for a int
 * @author Tomas Schackert
 *
 */
public class IntProperty extends Property{
	String key;
	int value=0;
	int defaultvalue;
	boolean loaded=false;
	public IntProperty(PropertySource props,IntProperty src){
		super(props);
		setInt(src);
	}
	
	public IntProperty(int value,int defaultValue){
		super(null);
		this.key=null;
		this.value=value;
		this.defaultvalue=defaultValue;
		loaded=true;
	}
	
	public IntProperty(PropertySource props,String key,int defaultvalue){
		super(props);
		this.key=key;
		this.defaultvalue=defaultvalue;
	}
	private void load(){
		value=this.getIntProperty(key,defaultvalue);
		loaded=true;
	}
	public void setInt(IntProperty src){
		if (!src.loaded)src.load();
		this.key=src.key;
		this.defaultvalue=src.defaultvalue;
		loaded=true;
		setInt(src.value);
	}
	public int getInt(){
		if (!loaded) load();
		return value;
	}
	public void setInt(int v){
		this.setIntProperty(key,this.value=v);
		fireChanged();
	}

	/**
	 * @see tmarkplugin.data.Property#reset()
	 */
	public void reset() {
		setInt(this.defaultvalue);		
	}
	
}
