/*
 *******************************************************************
 *              TMark favorites plugin for TVBrowser               *
 *                                                                 *
 * Copyright (C) 2006 Tomas Schackert.                             *
 * Contact koumori@web.de                                          *
 *******************************************************************

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, in version 2 of the License.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program, in a file called LICENSE in the top
 directory of the distribution; if not, write to 
 the Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
 Boston, MA  02111-1307  USA
 
 *******************************************************************/

package tmarkplugin.properties;




/**
 * 
 * @author Tomas Schackert
 *
 */
abstract public class ObjectProperty extends Property{
	String key;
	Object value=null;
	Object defaultvalue;
	public ObjectProperty(PropertySource props,ObjectProperty src){
		super(props);
		this.key=src.key;
		this.value=src.value;
		this.defaultvalue=src.defaultvalue;
	}
	public ObjectProperty(PropertySource props,String key,Object defaultvalue){
		super(props);
		this.key=key;
		this.defaultvalue=defaultvalue;
	}
	public ObjectProperty(Object value,Object defaultvalue){
		super(null);
		this.key=null;
		this.value=value;
		this.defaultvalue=defaultvalue;
	}
	abstract protected void load();
	abstract protected void save();
	public Object get(){
		if (value==null) load();
		return value;
	}
	public void set(Object v){
		if (v==this.value || (v!=null && v.equals(this.value)))return;
		this.value=v;
		save();
		fireChanged();
	}
	/**
	 * @see tmarkplugin.data.Property#reset()
	 */
	public void reset() {
		set(defaultvalue);
	}
}
